package com.ruoyi.board.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.yulichang.base.MPJBaseServiceImpl;
import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.ruoyi.board.domain.AlertPlan;
import com.ruoyi.board.domain.PlanType;
import com.ruoyi.board.domain.dto.AlertPlanAndPlanTypeDTO;
import com.ruoyi.board.mapper.AlertPlanMapper;
import com.ruoyi.board.service.IAlertPlanService;
import org.apache.commons.lang3.ObjectUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AlertPlanServiceImpl extends MPJBaseServiceImpl<AlertPlanMapper, AlertPlan> implements IAlertPlanService {

    private static final Logger log = LoggerFactory.getLogger(AlertPlanServiceImpl.class);

    @Override
    public List<AlertPlanAndPlanTypeDTO> listPage(AlertPlan alertPlan) {
        MPJLambdaWrapper<AlertPlan> eq = new MPJLambdaWrapper<AlertPlan>()
                .selectAll(AlertPlan.class)
                .select(PlanType::getTypeName)
                .leftJoin(PlanType.class, PlanType::getId, AlertPlan::getType)
                .eq(ObjectUtils.isNotEmpty(alertPlan.getType()), AlertPlan::getType, alertPlan.getType());
        return selectJoinList(AlertPlanAndPlanTypeDTO.class, eq);
    }

    @Override
    public AlertPlan getOneByTypeAndValue(Integer planType, Double value) {
        if (planType < 0) {
            return null;
        }
        LambdaQueryWrapper<AlertPlan> alertPlanLambdaQueryWrapper = new LambdaQueryWrapper<>();
        alertPlanLambdaQueryWrapper
                .eq(AlertPlan::getType, planType)
                .le(AlertPlan::getMinValue, value)
                .ge(AlertPlan::getMaxValue, value);
        return getOne(alertPlanLambdaQueryWrapper);
    }

    @Override
    public AlertPlanAndPlanTypeDTO getDTOById(Long id) {
        MPJLambdaWrapper<AlertPlan> eq = new MPJLambdaWrapper<AlertPlan>()
                .selectAll(AlertPlan.class)
                .select(PlanType::getTypeName)
                .leftJoin(PlanType.class, PlanType::getId, AlertPlan::getType)
                .eq(AlertPlan::getId, id);
        return selectJoinOne(AlertPlanAndPlanTypeDTO.class, eq);
    }

}
