package com.ruoyi.board.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.yulichang.base.MPJBaseServiceImpl;
import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.ruoyi.board.domain.BoardInfo;
import com.ruoyi.board.domain.BoardType;
import com.ruoyi.board.domain.RoadGroup;
import com.ruoyi.board.domain.dto.BoardInfoAndRoadDTO;
import com.ruoyi.board.mapper.BoardInfoMapper;
import com.ruoyi.board.service.IBoardInfoService;
import com.ruoyi.common.utils.StringUtils;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class BoardInfoServiceImpl extends MPJBaseServiceImpl<BoardInfoMapper, BoardInfo> implements IBoardInfoService {

    @Override
    public BoardInfo getOneByIP(String ip) {
        LambdaQueryWrapper<BoardInfo> boardInfoLambdaQueryWrapper = new LambdaQueryWrapper<>();
        boardInfoLambdaQueryWrapper.eq(BoardInfo::getBoardIp, ip);
        return getOne(boardInfoLambdaQueryWrapper);
    }

    @Override
    public List<BoardInfoAndRoadDTO> listBoardInfoDTO(BoardInfo boardInfo) {
        MPJLambdaWrapper<BoardInfo> eq = new MPJLambdaWrapper<BoardInfo>()
                .selectAll(BoardInfo.class)
                .select(RoadGroup::getRoadName)
                .selectAs(BoardType::getName, "board_size_name")
                .selectAs(BoardType::getSize, "board_size")
                .leftJoin(RoadGroup.class, RoadGroup::getId, BoardInfo::getBoardRoadSection)
                .leftJoin(BoardType.class, BoardType::getId, BoardInfo::getBoardSizeType)
                .likeRight(StringUtils.isNotEmpty(boardInfo.getBoardName()), BoardInfo::getBoardName, boardInfo.getBoardName())
                .likeRight(StringUtils.isNotEmpty(boardInfo.getBoardMileage()), BoardInfo::getBoardMileage, boardInfo.getBoardMileage())
                .eq(StringUtils.isNotEmpty(boardInfo.getBoardRoadSection()), BoardInfo::getBoardRoadSection, boardInfo.getBoardRoadSection());

        return selectJoinList(BoardInfoAndRoadDTO.class, eq);
    }
}
