import request from '@/utils/request'

// 查询情报板信息列表
export function listInfo(query) {
  return request({
    url: '/board/info/list',
    method: 'get',
    params: query
  })
}

// 查询情报板信息详细
export function getInfo(id) {
  return request({
    url: '/board/info/' + id,
    method: 'get'
  })
}

// 新增情报板信息
export function addInfo(data) {
  return request({
    url: '/board/info',
    method: 'post',
    data: data
  })
}

// 修改情报板信息
export function updateInfo(data) {
  return request({
    url: '/board/info',
    method: 'put',
    data: data
  })
}

// 删除情报板信息
export function delInfo(id) {
  return request({
    url: '/board/info/' + id,
    method: 'delete'
  })
}
