import request from '@/utils/request'

// 查询计划发布中的类型列表
export function listType(query) {
  return request({
    url: '/plan/type/list',
    method: 'get',
    params: query
  })
}

// 查询计划发布中的类型详细
export function getType(id) {
  return request({
    url: '/plan/type/' + id,
    method: 'get'
  })
}

// 新增计划发布中的类型
export function addType(data) {
  return request({
    url: '/plan/type',
    method: 'post',
    data: data
  })
}

// 修改计划发布中的类型
export function updateType(data) {
  return request({
    url: '/plan/type',
    method: 'put',
    data: data
  })
}

// 删除计划发布中的类型
export function delType(id) {
  return request({
    url: '/plan/type/' + id,
    method: 'delete'
  })
}

// 查询部门下拉树结构
export function planTypeTreeSelect() {
  return request({
    url: '/plan/type/planTree',
    method: 'get'
  })
}

